local uiPartner = Ui:GetClass("partner");
local tbObject	= Ui.tbLogic.tbObject;
local tbPreViewMgr = Ui.tbLogic.tbPreViewMgr;

uiPartner.BUTTON_CLOSE 		= "BtnClose";
uiPartner.BUTTON_PRESENT 	= "BtnPresent";
uiPartner.BUTTON_ACTIVE 	= "BtnActive";
uiPartner.BUTTON_DISBAND 	= "BtnDisband";
uiPartner.BUTTON_LEVEL_UP 	= "BtnLevelUp";
uiPartner.BUTTON_BINDEQUIP  = "BtnEquipBind";
uiPartner.BUTTON_CONVERT	= "BtnConvert";
uiPartner.LIST_PARTNER 		= "LstPartner";

uiPartner.IMG_CONVERT		= "ImgConvert";
uiPartner.TXT_ACCUMULATE_EXP = "TxtAccumulateExp";
uiPartner.TXT_NEED_EXP 		 = "TxtNeedExp";
uiPartner.TXT_FRIENDSHIP	 = "TxtFriendship";
uiPartner.TXT_TALENT	 	 = "TxtTalent";
uiPartner.TXT_ADD_STR 		 = "TxtAddStr";
uiPartner.TXT_ADD_DEX		 = "TxtAddDex";
uiPartner.TXT_ADD_VIT		 = "TxtAddVit";
uiPartner.TXT_ADD_ENG		 = "TxtAddEng";
uiPartner.TXT_START		 	 = "TxtStart";
uiPartner.TXT_PARTNER_LIST	 = "TxtPartnerList";
uiPartner.SZ_TXT_SKILL_LV	 = "TxtSkillLv";
uiPartner.TXT_FIGHTPOWER	 = "TxtFightPower";
uiPartner.IMG_VKHI	 = "ImgWeapon1";
uiPartner.IMG_Ao	 = "ImgBody1";
uiPartner.IMG_NHAN	 = "ImgRing1";
uiPartner.IMG_TAY	 = "ImgCuff1";
uiPartner.IMG_PHU	 = "ImgAmulet1";
uiPartner.IMG_EFFECT	 = "ImgEffectTBi";
uiPartner.IMG_NECKLACE	 = "ImgNecklace";
uiPartner.IMG_BELT	 = "ImgBelt";
uiPartner.IMG_FOOT	 = "ImgFoot";
uiPartner.IMG_PEDANT	 = "ImgPedant";
uiPartner.IMG_HEAD	 = "ImgHead";
uiPartner.TXT_SKILL_LV 		 = {};
uiPartner.OBJ_PARTNER_PREVIEW 	= "ObjPartnerPreview";
uiPartner.OBJ_SKILL_PREVIEW 	= "ObjSkillPreview";
uiPartner.CONVERT_EFFECT	 = "ImgConvertEffect";
uiPartner.OBJ_SKILL_CONFIGER = { bShowCd = 1, bUse = 0, bLink = 0, bSwitch = 0 };	-- 对应同伴技能
uiPartner.ROWCOUNT = 5;
uiPartner.PARTNER_VALUE = { TEMP_ID = 0, EXP = 1, LEVEL = 2, FRIENDSHIP = 3, TALENT = 4 }; -- 对应代码中的 emPARTNER_VALUE
uiPartner.PARTNER_ATTRIB = {STR = 0, DEX = 1, VIT = 2, ENG = 3}; -- 对应代码中的 emPARTNER_ATTRIB
uiPartner.MAX_SKILL_COUNT = 10;

local PARTNER_EQUIP_OBJ_CONFIGER =
{
	{Item.PARTNEREQUIP_WEAPON,	"ObjWeapon",	"ImgWeapon"},	-- 同伴装备--武器
	{Item.PARTNEREQUIP_BODY,	"ObjBody",		"ImgBody"},		-- 同伴装备--衣服
	{Item.PARTNEREQUIP_RING,	"ObjRing",		"ImgRing"},		-- 同伴装备--戒指
	{Item.PARTNEREQUIP_CUFF,	"ObjCuff",		"ImgCuff"},		-- 同伴装备--护腕
	{Item.PARTNEREQUIP_AMULET,	"ObjAmulet",	"ImgAmulet"},	-- 同伴装备--护身符
}

local tbPartnerEquipCont = { bShowCd = 0, bUse = 0, bLink = 0, nRoom = Item.ROOM_PARTNEREQUIP };	-- 对应同伴装备栏
function uiPartner:OnCreate()
	self.nSelect = 1;
	self.tbSkillIds = {};
	self.tbObjPartnerView = {};
	self.tbObjSkillView = {};
	self.tbObjPartnerView = tbObject:RegisterContainer(self.UIGROUP, self.OBJ_PARTNER_PREVIEW);
	self.tbObjSkillView = tbObject:RegisterContainer(self.UIGROUP, self.OBJ_SKILL_PREVIEW, 5, 2, self.OBJ_SKILL_CONFIGER, "SkillView");
	self.tbObjEquipView = {};
	for i, tbCon in pairs(PARTNER_EQUIP_OBJ_CONFIGER) do
		local nPos = tbCon[1];
		self.tbObjEquipView[nPos] = tbObject:RegisterContainer(
			self.UIGROUP,
			tbCon[2],
			1,
			1,
			{ nOffsetX = nPos, nRoom = Item.ROOM_PARTNEREQUIP },	-- 加上偏移量
			"equiproom"
		);
	end
	
	for i = 1, self.MAX_SKILL_COUNT do
		self.TXT_SKILL_LV[i] = self.SZ_TXT_SKILL_LV..i;
	end
end

function uiPartner:OnKillFocus(szWnd)
	UiManager:CloseWindow(self.UIGROUP);
end

function uiPartner:OnDestroy()
	tbObject:UnregContainer(self.tbObjPartnerView);
	tbObject:UnregContainer(self.tbObjSkillView);
	for _, tbCont in pairs(self.tbObjEquipView) do
		tbObject:UnregContainer(tbCont);
	end
end

function uiPartner:OnClose()
	for _, tbCont in pairs(self.tbObjEquipView) do
		tbCont:ClearRoom();
	end
end

function uiPartner:OnListSel(szWnd, nParam)
	if szWnd == self.LIST_PARTNER then
		local nKey = Lst_GetCurKey(self.UIGROUP, self.LIST_PARTNER);
		self.nSelect = nKey;
		self:UpdatePartner(self.nSelect - 1);
	end
end

function uiPartner:OnObjGridEnter(szWnd, nX, nY)
	if Wnd_Visible(self.UIGROUP, "Main") == 0 then
		return;
	end

	if (szWnd == self.OBJ_SKILL_PREVIEW) then
		local nOffset = 0;
		if nY > 0 then
			nOffset = 5;
		else
			nOffset = 1;
		end
		local uId = nX + nOffset + nY;
		if self.tbSkillIds[uId] then
			Wnd_ShowMouseHoverInfo(self.UIGROUP, szWnd, 
								FightSkill:GetDesc(self.tbSkillIds[uId].nId,
				 				self.tbSkillIds[uId].nLevel));
		end
	end

end

function uiPartner:OnOpen()
	if (Partner.bOpenPartner == 0) then
		return 0;
	end
	
	Wnd_SetVisible(self.UIGROUP, "Main", 1);
	if me.nActivePartner ~= -1 then
		self.nSelect = me.nActivePartner + 1;
	end
	self:Update();
end

function uiPartner:UpdateList()
	Lst_Clear(self.UIGROUP, self.LIST_PARTNER);
	for nIndex = 1, me.nPartnerCount do
		local pPartner = me.GetPartner(nIndex - 1);
		if pPartner then
			Lst_SetCell(self.UIGROUP, self.LIST_PARTNER, nIndex, 1, "   "..pPartner.szName);
			Lst_SetCell(self.UIGROUP, self.LIST_PARTNER, nIndex, 2, pPartner.GetValue(self.PARTNER_VALUE.LEVEL).."");
		end
	end
	
	if me.nActivePartner ~= -1 then
		local pPartner = me.GetPartner(me.nActivePartner);
		if pPartner then
			Lst_SetCell(self.UIGROUP, self.LIST_PARTNER, 
					me.nActivePartner + 1, 1, "<color=orange>★ <color>"..pPartner.szName);
		end
	end
end

function uiPartner:Update()
	if Wnd_Visible(self.UIGROUP, "Main") == 0 then
		return;
	end

	Wnd_SetEnable(self.UIGROUP,self.BUTTON_LEVEL_UP, 0);
	Wnd_SetEnable(self.UIGROUP,self.BUTTON_PRESENT, 0);
	Txt_SetTxt(self.UIGROUP, self.TXT_PARTNER_LIST, "Danh sách đồng hành ("..me.nPartnerCount.."/"..me.nPartnerLimit..")")
	
	self:UpdateList();
	self:UpdateImgVKhiPet();
	self:UpdateImgLienPet();
	self:UpdateImgLungPet();
	self:UpdateImgGiayPet();
	self:UpdateImgBoiPet();
	self:UpdateImgNonPet();
	self:UpdateImgAoPet();
	self:UpdateImgNhanPet();
	self:UpdateImgTayPet();
	self:UpdateImgPhuPet();
	if self.nSelect > me.nPartnerCount and me.nPartnerCount > 0 and me.nPartnerCount <= me.nPartnerLimit then
		if me.nActivePartner ~= -1 then
			self.nSelect = me.nActivePartner + 1;
		else
			self.nSelect = 1;
		end
	end
	Lst_SetCurKey(self.UIGROUP, self.LIST_PARTNER, self.nSelect);
	
	self:UpdatePartner(self.nSelect - 1);
	
	self:UpdatePartnerEquip();
	return 1;
end

function uiPartner:UpdatePartner(nPartnerIndex)
	self:UpdatePartnerInfo(nPartnerIndex);
	self:UpdatePartnerView(nPartnerIndex);
	self:UpdateSkillView(nPartnerIndex);
end
function uiPartner:UpdateImgVKhiPet()
	local nLevel = me.GetSkillLevel(1988)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\weapon\\partner_lv1_1_s.spr",
		[2] = "\\image\\item\\partnerequip\\weapon\\partner_lv2_1_s.spr",
		[3] = "\\image\\item\\partnerequip\\weapon\\partner_lv3_1_s.spr",
		[4] = "\\image\\item\\partnerequip\\weapon\\partner_lv4_1_s.spr",
		[5] = "\\image\\item\\partnerequip\\weapon\\partner_lv5_1_s.spr",
		[6] = "\\image\\item\\partnerequip\\weapon\\partner_lv6_1_s.spr",
		[7] = "\\image\\item\\partnerequip\\weapon\\partner_lv6_1_s.spr",
		[8] = "\\image\\item\\partnerequip\\weapon\\partner_lv7_1_s.spr",
	};	
		Img_SetImage(self.UIGROUP, self.IMG_VKHI, 1, szSpr[nLevel]);		
end
function uiPartner:UpdateImgAoPet()
	local nLevel = me.GetSkillLevel(1989)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\body\\partner_lv1_2_s.spr",
		[2] = "\\image\\item\\partnerequip\\body\\partner_lv2_2_s.spr",
		[3] = "\\image\\item\\partnerequip\\body\\partner_lv3_2_s.spr",
		[4] = "\\image\\item\\partnerequip\\body\\partner_lv4_2_s.spr",
		[5] = "\\image\\item\\partnerequip\\body\\partner_lv5_2_s.spr",
		[6] = "\\image\\item\\partnerequip\\body\\partner_lv6_2_s.spr",
		[7] = "\\image\\item\\partnerequip\\body\\partner_lv6_2_s.spr",
		[8] = "\\image\\item\\partnerequip\\body\\partner_lv7_2_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_Ao, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgNhanPet()
	local nLevel = me.GetSkillLevel(1990)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\ring\\partner_ring_01_s.spr",
		[2] = "\\image\\item\\partnerequip\\ring\\partner_ring_02_s.spr",
		[3] = "\\image\\item\\partnerequip\\ring\\partner_ring_03_s.spr",
		[4] = "\\image\\item\\partnerequip\\ring\\partner_ring_04_s.spr",
		[5] = "\\image\\item\\partnerequip\\ring\\partner_ring_05_s.spr",
		[6] = "\\image\\item\\partnerequip\\ring\\partner_ring_06_s.spr",
		[7] = "\\image\\item\\partnerequip\\ring\\partner_ring_06_s.spr",
		[8] = "\\image\\item\\partnerequip\\ring\\partner_ring_07_s.spr",
	};
	Img_SetImage(self.UIGROUP, self.IMG_NHAN, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgTayPet()
	local nLevel = me.GetSkillLevel(1991)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_01_s.spr",
		[2] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_02_s.spr",
		[3] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_03_s.spr",
		[4] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_04_s.spr",
		[5] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_05_s.spr",
		[6] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_06_s.spr",
		[7] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_06_s.spr",
		[8] = "\\image\\item\\partnerequip\\cuff\\partner_cuff_07_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_TAY, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgPhuPet()
	local nLevel = me.GetSkillLevel(1992)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\amulet\\partner_lv1_3_s.spr",
		[2] = "\\image\\item\\partnerequip\\amulet\\partner_lv2_3_s.spr",
		[3] = "\\image\\item\\partnerequip\\amulet\\partner_lv3_3_s.spr",
		[4] = "\\image\\item\\partnerequip\\amulet\\partner_lv4_3_s.spr",
		[5] = "\\image\\item\\partnerequip\\amulet\\partner_lv5_3_s.spr",
		[6] = "\\image\\item\\partnerequip\\amulet\\partner_lv6_3_s.spr",
		[7] = "\\image\\item\\partnerequip\\amulet\\partner_lv6_3_s.spr",
		[8] = "\\image\\item\\partnerequip\\amulet\\partner_lv7_3_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_PHU, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgLienPet()
	local nLevel = me.GetSkillLevel(1993)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_01_s.spr",
		[2] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_02_s.spr",
		[3] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_03_s.spr",
		[4] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_04_s.spr",
		[5] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_05_s.spr",
		[6] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_06_s.spr",
		[7] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_06_s.spr",
		[8] = "\\image\\item\\partnerequip\\necklace\\partner_necklace_07_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_NECKLACE, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgLungPet()
	local nLevel = me.GetSkillLevel(1994)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\belt\\partner_belt_01_s.spr",
		[2] = "\\image\\item\\partnerequip\\belt\\partner_belt_02_s.spr",
		[3] = "\\image\\item\\partnerequip\\belt\\partner_belt_03_s.spr",
		[4] = "\\image\\item\\partnerequip\\belt\\partner_belt_04_s.spr",
		[5] = "\\image\\item\\partnerequip\\belt\\partner_belt_05_s.spr",
		[6] = "\\image\\item\\partnerequip\\belt\\partner_belt_06_s.spr",
		[7] = "\\image\\item\\partnerequip\\belt\\partner_belt_06_s.spr",
		[8] = "\\image\\item\\partnerequip\\belt\\partner_belt_07_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_BELT, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgGiayPet()
	local nLevel = me.GetSkillLevel(1995)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv1_s.spr",
		[2] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv2_s.spr",
		[3] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv3_s.spr",
		[4] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv4_s.spr",
		[5] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv5_s.spr",
		[6] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv6_s.spr",
		[7] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv6_s.spr",
		[8] = "\\image\\item\\partnerequip\\foot\\partner_foot_lv7_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_FOOT, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgBoiPet()
	local nLevel = me.GetSkillLevel(1996)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv1_s.spr",
		[2] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv2_s.spr",
		[3] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv3_s.spr",
		[4] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv4_s.spr",
		[5] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv5_s.spr",
		[6] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv6_s.spr",
		[7] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv6_s.spr",
		[8] = "\\image\\item\\partnerequip\\pendant\\partner_pendant_lv7_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_PEDANT, 1, szSpr[nLevel]);
end
function uiPartner:UpdateImgNonPet()
	local nLevel = me.GetSkillLevel(1997)
	local szSpr = {
		[1] = "\\image\\item\\partnerequip\\head\\partner_head_lv1_s.spr",
		[2] = "\\image\\item\\partnerequip\\head\\partner_head_lv2_s.spr",
		[3] = "\\image\\item\\partnerequip\\head\\partner_head_lv3_s.spr",
		[4] = "\\image\\item\\partnerequip\\head\\partner_head_lv4_s.spr",
		[5] = "\\image\\item\\partnerequip\\head\\partner_head_lv5_s.spr",
		[6] = "\\image\\item\\partnerequip\\head\\partner_head_lv6_s.spr",
		[7] = "\\image\\item\\partnerequip\\head\\partner_head_lv6_s.spr",
		[8] = "\\image\\item\\partnerequip\\head\\partner_head_lv7_s.spr",
	};	
	Img_SetImage(self.UIGROUP, self.IMG_HEAD, 1, szSpr[nLevel]);
end
function uiPartner:UpdatePartnerView(nPartnerIndex)
	if not self.tbObjPartnerView.szObjGrid then
		print("No tbObjPartnerView");
		return;
	end
	self.tbObjPartnerView:ClearObj();
	if nPartnerIndex < 0 or  nPartnerIndex >= me.nPartnerCount then
		return;
	end
	local pPartner = me.GetPartner(nPartnerIndex);
	if not pPartner then
		return;
	end
	
	local tbPart = tbPreViewMgr:GetSelfPart();
	local nNpcId = Partner.tbPartIdToNpcId[pPartner.GetValue(self.PARTNER_VALUE.TEMP_ID)];
	if not nNpcId then
		return;
	end
	local tbObj = {};
	tbObj.nType = Ui.OBJ_NPCRES;
	tbObj.nTemplateId = nNpcId;
	tbObj.nAction = Npc.ACT_STAND1;
	tbObj.tbPart = tbPart;
	tbObj.nDir = 0;
	tbObj.bRideHorse = 0;
	self.tbObjPartnerView:SetObj(tbObj);
end

function uiPartner:UpdateSkillView(nPartnerIndex)
	self.tbSkillIds = {};
	if not self.tbObjSkillView.szObjGrid then
		print("No tbObjSkillView")
		return;
	end
	self.tbObjSkillView:ClearObj();
	self:ClearSkillLevel();
	if nPartnerIndex < 0 or  nPartnerIndex >= me.nPartnerCount then
		return;
	end
	local pPartner = me.GetPartner(nPartnerIndex);
	if not pPartner then
		return;
	end

	for nIndex = 1, pPartner.nSkillCount do
		table.insert(self.tbSkillIds, pPartner.GetSkill(nIndex - 1));
	end

		   	
	local nRow = 0;
	local nLine = 0;
	for nIndex, tbPartnerSkill in ipairs(self.tbSkillIds) do
		nRow = nIndex - 1;
		if nIndex > self.ROWCOUNT and self.ROWCOUNT > 0 then
			nRow = nRow - self.ROWCOUNT;
			nLine = math.floor(nRow / self.ROWCOUNT) + 1;
		end
		local tbSkill = {};
		tbSkill.nType = Ui.OBJ_FIGHTSKILL;
		tbSkill.nSkillId = tbPartnerSkill.nId;
		self.tbObjSkillView:SetObj(tbSkill, nRow, nLine);
		ObjBox_Clear(self.UIGROUP, Ui.OBJ_FIGHTSKILL);
		ObjBox_HoldObject(self.UIGROUP, self.OBJ_SKILL_PREVIEW, Ui.CGOG_SKILL_SHORTCUT, tbPartnerSkill.nId);	
		Txt_SetTxt(self.UIGROUP, self.TXT_SKILL_LV[nIndex], tbPartnerSkill.nLevel);	
	end
end

function uiPartner:UpdatePartnerEquip()
	for i, tbCont in pairs(self.tbObjEquipView) do
		tbCont:UpdateRoom();
	end
end

function uiPartner:UpdateEquipDur()
	for _, tbCont in pairs(self.tbObjEquipView) do
		if tbCont then
			local pItem = me.GetItem(tbCont.nRoom, tbCont.nOffsetX, tbCont.nOffsetY);
			if pItem then
				if tbCont.nOffsetX >= Item.PARTNEREQUIP_WEAPON and tbCont.nOffsetY <= Item.PARTNEREQUIP_AMULET then
					ObjGrid_ShowSubScript(tbCont.szUiGroup, tbCont.szObjGrid, 1, 0, 0);
					local nPerDur = math.ceil((pItem.nCurDur / pItem.nMaxDur) * 100)
					if nPerDur > 0 and nPerDur <= 10 then
						ObjGrid_ChangeSubScriptColor(tbCont.szUiGroup, tbCont.szObjGrid, "Red");
					elseif nPerDur > 10 and nPerDur <= 60 then
						ObjGrid_ChangeSubScriptColor(tbCont.szUiGroup, tbCont.szObjGrid, "yellow");
					elseif nPerDur > 60 then
						ObjGrid_ChangeSubScriptColor(tbCont.szUiGroup, tbCont.szObjGrid, "green");
					end;
				
					local szDur = tostring(nPerDur).."%";
					ObjGrid_ChangeSubScript(tbCont.szUiGroup, tbCont.szObjGrid, szDur, 0, 0);
				end
			end
		end
	end
end

function uiPartner:ClearSkillLevel()
	for i = 1, self.MAX_SKILL_COUNT do
		Txt_SetTxt(self.UIGROUP, self.TXT_SKILL_LV[i], "");	
	end
end

function uiPartner:UpdatePartnerInfo(nPartnerIndex)
	local szAccumulateExp =  "Kinh nghiệm hiện tại: ";
	local szNeedExp = "Kinh nghiệm cần: ";
	local szFriendship = "Thân mật: ";
	local szTalent = "Lĩnh ngộ: ";
	local szAddStr = "Sức mạnh tăng: ";
	local szAddDex = "Thân pháp tăng: ";
	local szTxtAddVit = "Ngoại công tăng: ";
	local szTxtAddEng = "Nội công tăng: ";
	local szFightPower = "Tăng sức chiến đấu: ";
	local szStart = "";

	if nPartnerIndex >= 0 and nPartnerIndex < me.nPartnerCount then
		local pPartner = me.GetPartner(nPartnerIndex);
		if pPartner then
			szStart = self:SetStart(nPartnerIndex);
			szAccumulateExp = szAccumulateExp..pPartner.GetValue(self.PARTNER_VALUE.EXP);
			szNeedExp = szNeedExp..Partner:GetNeedLevel(pPartner.GetValue(self.PARTNER_VALUE.LEVEL));
			local szTemp = string.format("%0.2f", pPartner.GetValue(self.PARTNER_VALUE.FRIENDSHIP) / 100);
			szFriendship = szFriendship..szTemp;
			local nTalent = pPartner.GetValue(self.PARTNER_VALUE.TALENT) % 1000
			szTalent = szTalent..nTalent;
			szAddStr = szAddStr..pPartner.GetAttrib(self.PARTNER_ATTRIB.STR);
			szAddDex = szAddDex..pPartner.GetAttrib(self.PARTNER_ATTRIB.DEX);
			szTxtAddVit = szTxtAddVit..pPartner.GetAttrib(self.PARTNER_ATTRIB.VIT);
			szTxtAddEng = szTxtAddEng..pPartner.GetAttrib(self.PARTNER_ATTRIB.ENG);
		end
	end
	local nKey = Lst_GetCurKey(self.UIGROUP, self.LIST_PARTNER);
	if me.nActivePartner ~= nKey - 1 or me.nActivePartner == -1 then
		Btn_SetTxt(self.UIGROUP, self.BUTTON_ACTIVE, "Giúp đỡ");
		Wnd_SetEnable(self.UIGROUP,self.BUTTON_LEVEL_UP, 0);
		Wnd_SetEnable(self.UIGROUP,self.BUTTON_PRESENT, 0);
	else
		Btn_SetTxt(self.UIGROUP, self.BUTTON_ACTIVE, "Đứng nhìn");
		Wnd_SetEnable(self.UIGROUP,self.BUTTON_LEVEL_UP, 1);
		Wnd_SetEnable(self.UIGROUP,self.BUTTON_PRESENT, 1);
	end
	Txt_SetTxt(self.UIGROUP, self.TXT_START, szStart);
	Txt_SetTxt(self.UIGROUP, self.TXT_ACCUMULATE_EXP, szAccumulateExp);
	Txt_SetTxt(self.UIGROUP, self.TXT_NEED_EXP, szNeedExp);
	Txt_SetTxt(self.UIGROUP, self.TXT_FRIENDSHIP, szFriendship);
	Txt_SetTxt(self.UIGROUP, self.TXT_TALENT, szTalent);
	Txt_SetTxt(self.UIGROUP, self.TXT_ADD_STR, szAddStr);
	Txt_SetTxt(self.UIGROUP, self.TXT_ADD_DEX, szAddDex);
	Txt_SetTxt(self.UIGROUP, self.TXT_ADD_VIT, szTxtAddVit);
	Txt_SetTxt(self.UIGROUP, self.TXT_ADD_ENG, szTxtAddEng);
end

function uiPartner:SetStart(nPartnerIndex)
	local szTip = "\n  ";
	if not nPartnerIndex then
		return szTip;
	end
	local tbSetting = Partner.tbStarLevel;
	local pPartner = me.GetPartner(nPartnerIndex);
	if not pPartner then
		return szTip;
	end
	local nStartCount = Partner:GetSelfStartCount(pPartner);
	local szFillStar = "";
	local szEmptyStar = "";
	if tbSetting and tbSetting[nStartCount] then
		szFillStar = string.format("<pic=%s>", tbSetting[nStartCount].nFillStar - 1);
		szEmptyStar = string.format("<pic=%s>", tbSetting[nStartCount].nEmptyStar - 1);
	else
		szFillStar = "★";
		szEmptyStar = "☆";
	end

	for i = 1, math.floor(nStartCount / 2) do
		szTip = szTip..szFillStar;
		if i % 3 == 0 then
			szTip = szTip.." ";
		end
	end
	if (nStartCount % 2 ~= 0) then
		szTip = szTip..szEmptyStar;
	end
	return	szTip;
end
function uiPartner:OnButtonClick(szWnd, nParam)
	if (szWnd == self.BUTTON_CLOSE) then
		UiManager:CloseWindow(self.UIGROUP);
	elseif (szWnd == self.BUTTON_PRESENT) then
		if me.nActivePartner >= 0 and me.nActivePartner <= me.nPartnerLimit then
			me.CallServerScript({ "PartnerCmd", "SendGift", me.nActivePartner});
		end
	elseif (szWnd == self.BUTTON_LEVEL_UP) then
		if me.nActivePartner >= 0 and me.nActivePartner <= me.nPartnerLimit then
			me.CallServerScript({ "PartnerCmd", "UpgradeLevel", me.nActivePartner});
		end
	elseif (szWnd == self.BUTTON_ACTIVE) then
		local nKey = Lst_GetCurKey(self.UIGROUP, self.LIST_PARTNER);
		if nKey > 0 and nKey <= me.nPartnerLimit then
			me.CallServerScript({ "PartnerCmd", "CallPartner", nKey - 1});
		else
			me.Msg("Hãy chọn đồng hành cần thao tác");
		end
	elseif (szWnd == self.BUTTON_DISBAND) then
		local nKey = Lst_GetCurKey(self.UIGROUP, self.LIST_PARTNER);
		if nKey > 0 and nKey <= me.nPartnerLimit then
			me.CallServerScript({ "PartnerCmd", "DissolvePartner", nKey - 1});
		else
			me.Msg("Hãy chọn đồng hành cần giải tán");
		end
	elseif (szWnd == self.BUTTON_BINDEQUIP) then
		me.CallServerScript({"PartnerCmd", "BindEquip", me.nId});
	elseif (szWnd == self.BUTTON_CONVERT) then
		local nKey = Lst_GetCurKey(self.UIGROUP, self.LIST_PARTNER);
		if nKey > 0 and nKey <= me.nPartnerLimit then
			me.CallServerScript({"PartnerCmd", "Convert", nKey - 1});
		else
			me.Msg("Hãy chọn đồng hành mà bạn muốn chuyển hóa");
		end
	end
end

uiPartner.tbInfoPartnerEquip_Define = {
	szColor = {"gold", "gold", "yellow", "yellow"},
	szType = {"Bích Huyết", "Kim Lân", "Đơn Tâm", "Long Đằng", "Long Đằng (Huyền)", "Long Đằng (Địa)", "Long Đằng (Thiên)", "Long Đằng (Thần)"},
	szStars = {
		"<pic=153><pic=153><pic=153><pic=153><pic=153><pic=153><pic=153><pic=152>",
		"<pic=153><pic=153><pic=153><pic=153><pic=153><pic=153><pic=153><pic=153>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=154>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155>",
		"<pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155><pic=155>",
	},
	nHonor = {1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000},
};
uiPartner.tbInfoPartnerEquip = {
	[1988] = { -- Vũ Khí
		szDesc = 
		"<color=green>Tỉ lệ sinh lực tối đa: <color=gold>Tăng %d%%<color>\n"..
		"Tấn công khi đánh chí mạng: <color=gold>+%d%%<color><color>",
		tbInfo = {
			[1] = {10, 15},
			[2] = {15, 23},
			[3] = {23, 35},
			[4] = {34, 52},
			[5] = {45, 69},
			[6] = {56, 86},
			[7] = {67, 103},
			[8] = {78, 120},
		},		
	},	
	[1989] = { -- Áo
		szDesc = 
		"<color=green>Tỉ lệ nội lực tối đa: <color=gold>Tăng %d%%<color>\n"..
		"Chịu sát thương chí mạng: <color=gold>-%d%%<color><color>",
		tbInfo = {
			[1] = {10, 15},
			[2] = {15, 22},
			[3] = {22, 33},
			[4] = {33, 50},
			[5] = {44, 67},
			[6] = {55, 84},
			[7] = {66, 101},
			[8] = {77, 118},
		},		
	},	
	[1990] = { -- Nhẫn
		szDesc = 
		"<color=green>Vật công ngoại: <color=gold>+%d%%<color>\n"..
		"Vật công nội: <color=gold>+%d%%<color>\n"..
		"Hiệu suất phục hồi nội lực: <color=gold>+%d%%<color>\n"..
		"Thời gian bị trạng thái ngũ hành: <color=gold>-%d<color><color>",
		tbInfo = {
			[1] = {100, 100, 11, 50},
			[2] = {150, 150, 16, 75},
			[3] = {225, 225, 24, 112},
			[4] = {337, 337, 37, 168},
			[5] = {449, 449, 50, 224},
			[6] = {561, 561, 63, 280},
			[7] = {673, 673, 76, 336},
			[8] = {785, 785, 89, 392},
		},		
	},	
	[1991] = { -- Tay
		szDesc = 
		"<color=green>Kháng tất cả: <color=gold>+%d<color>\n"..
		"Hiệu Suất phụ hồi sinh lực: <color=gold>+%d%%<color><color>",
		tbInfo = {
			[1] = {75, 11},
			[2] = {112, 16},
			[3] = {168, 24},
			[4] = {180, 37},
			[5] = {192, 50},
			[6] = {204, 63},
			[7] = {216, 76},
			[8] = {228, 89},
		},		
	},	
	[1992] = { -- Phù
		szDesc = 
		"<color=green>Mỗi 5 giây hồi phục sinh lực: <color=gold>+%d điểm<color>\n"..
		"Mỗi 5 giây hồi phục nội lực: <color=gold>+%d điểm<color>\n"..
		"Mỗi 5 giây hồi phục thể lực: <color=gold>+%d điểm<color>\n"..
		"Kháng tất cả: <color=gold>+%d<color><color>",
		tbInfo = {
			[1] = {30, 30, 30, 15},
			[2] = {45, 45, 45, 22},
			[3] = {67, 67, 67, 33},
			[4] = {101, 101, 101, 50},
			[5] = {135, 135, 135, 67},
			[6] = {169, 169, 169, 84},
			[7] = {203, 203, 203, 101},
			[8] = {237, 237, 237, 118},
		},		
	},	
	[1993] = { -- Liên
		szDesc = 
		"<color=green>Phát huy lực tấn công cơ bản: <color=gold>+%d%%<color>\n"..
		"Bỏ qua né tránh đối thủ: <color=gold>+%d<color>\n"..
		"Chuyển hóa sát thương thành nội lựcTrả lời: <color=gold>+%d%%<color>\n"..
		"Cường hóa ngũ hành tương khắc: <color=gold>+%d điểm<color><color>",
		tbInfo = {
			[1] = {17, 415, 3, 135},
			[2] = {25, 622, 4, 202},
			[3] = {38, 933, 6, 303},
			[4] = {57, 1400, 10, 455},
			[5] = {76, 1867, 14, 607},
			[6] = {95, 2334, 18, 759},
			[7] = {114, 2801, 22, 911},
			[8] = {133, 3268, 26, 1063},
		},		
	},
	[1994] = { -- Lưng
		szDesc = 
		"<color=green>Kháng tất cả: <color=gold>+%d<color>\n"..
		"Sinh lực tối đa: <color=gold>+%d điểm<color>\n"..
		"Nhược hóa ngũ hành tương khắc: <color=gold>+%d điểm<color><color>",
		tbInfo = {
			[1] = {70, 500, 55},
			[2] = {105, 1000, 135},
			[3] = {157, 1500, 205},
			[4] = {236, 2250, 307},
			[5] = {315, 3000, 409},
			[6] = {394, 3750, 511},
			[7] = {473, 4500, 613},
			[8] = {552, 5250, 715},
		},		
	},	
	[1995] = { -- Giày
		szDesc = 
		"<color=green>Tăng vật công ngoại: <color=gold>+%d điểm<color>\n"..
		"Tăng vật công nội: <color=gold>+%d điểm<color>\n"..
		"Tăng tỷ lệ chí mạng: <color=gold>+%d%%<color><color>",
		tbInfo = {
			[1] = {2560, 2560, 10},
			[2] = {4100, 4100, 15},
			[3] = {5760, 5760, 22},
			[4] = {8640, 8640, 33},
			[5] = {11520, 11520, 44},
			[6] = {14400, 14400, 55},
			[7] = {17280, 17280, 66},
			[8] = {20160, 20160, 77},
		},		
	},
	[1996] = { -- Bội
		szDesc = 
		"<color=green>Phát huy lực tấn công cơ bản: <color=gold>+%d%%<color>\n"..
		"Phát huy lực tấn công kỹ năng: <color=gold>+%d%%<color>\n"..
		"Thể lực tối đa: <color=gold>+%d điểm<color><color>",
		tbInfo = {
			[1] = {5, 5, 500},
			[2] = {10, 10, 750},
			[3] = {15, 15, 1125},
			[4] = {22, 22, 1687},
			[5] = {29, 29, 2249},
			[6] = {36, 36, 2811},
			[7] = {43, 43, 3373},
			[8] = {50, 50, 5935},
		},		
	},	
	[1997] = { -- Nón
		szDesc = 
		"<color=green>Kháng tất cả: <color=gold>+%d<color>\n"..
		"Nhược hóa ngũ hành tương khắc: <color=gold>+%d<color>\n"..
		"Chịu sát thương chí mạng: <color=gold>-%d%%<color><color>",
		tbInfo = {
			[1] = {50, 50, 10},
			[2] = {100, 135, 15},
			[3] = {150, 205, 22},
			[4] = {225, 307, 33},
			[5] = {300, 409, 44},
			[6] = {375, 511, 55},
			[7] = {450, 613, 66},
			[8] = {525, 715, 77},
		},		
	},	
};

function uiPartner:OnMouseEnter(szWnd)
	local LvPartner_Lien = me.GetSkillLevel(1993)
	local LvPartner_Lung = me.GetSkillLevel(1994)
	local LvPartner_Giay = me.GetSkillLevel(1995)
	local LvPartner_Boi = me.GetSkillLevel(1996)
	local LvPartner_Non = me.GetSkillLevel(1997)
	local LvPartner_VuKhi = me.GetSkillLevel(1988)
	local LvPartner_Ao = me.GetSkillLevel(1989)
	local LvPartner_Nhan = me.GetSkillLevel(1990)
	local LvPartner_Tay = me.GetSkillLevel(1991)
	local LvPartner_Phu = me.GetSkillLevel(1992)
	local szTip = "";
	if (szWnd == self.IMG_NECKLACE) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Lien] .." Hạng Liên<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Lien] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Lien] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Lien.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1993].szDesc .."",
		self.tbInfoPartnerEquip[1993].tbInfo[LvPartner_Lien][1],
		self.tbInfoPartnerEquip[1993].tbInfo[LvPartner_Lien][2],
		self.tbInfoPartnerEquip[1993].tbInfo[LvPartner_Lien][3],
		self.tbInfoPartnerEquip[1993].tbInfo[LvPartner_Lien][4]);
	elseif (szWnd == self.IMG_BELT) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Lung] .." Thúc Yêu<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Lung] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Lung] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Lung.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1994].szDesc .."",
		self.tbInfoPartnerEquip[1994].tbInfo[LvPartner_Lung][1],
		self.tbInfoPartnerEquip[1994].tbInfo[LvPartner_Lung][2],
		self.tbInfoPartnerEquip[1994].tbInfo[LvPartner_Lung][3]);
	elseif (szWnd == self.IMG_FOOT) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Giay] .." Chiến Ngoa<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Giay] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Giay] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Giay.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1995].szDesc .."",
		self.tbInfoPartnerEquip[1995].tbInfo[LvPartner_Giay][1],
		self.tbInfoPartnerEquip[1995].tbInfo[LvPartner_Giay][2],
		self.tbInfoPartnerEquip[1995].tbInfo[LvPartner_Giay][3]);
	elseif (szWnd == self.IMG_PEDANT) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Boi] .." Ngọc Bội<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Boi] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Boi] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Boi.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1996].szDesc .."",
		self.tbInfoPartnerEquip[1996].tbInfo[LvPartner_Boi][1],
		self.tbInfoPartnerEquip[1996].tbInfo[LvPartner_Boi][2],
		self.tbInfoPartnerEquip[1996].tbInfo[LvPartner_Boi][3]);
	elseif (szWnd == self.IMG_HEAD) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Non] .." Chi Quán<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Non] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Non] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Non.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1997].szDesc .."",
		self.tbInfoPartnerEquip[1997].tbInfo[LvPartner_Non][1],
		self.tbInfoPartnerEquip[1997].tbInfo[LvPartner_Non][2],
		self.tbInfoPartnerEquip[1997].tbInfo[LvPartner_Non][3]);
	elseif (szWnd == self.IMG_VKHI) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_VuKhi] .." Chi Nhẫn<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_VuKhi] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_VuKhi] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_VuKhi.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1988].szDesc .."",
		self.tbInfoPartnerEquip[1988].tbInfo[LvPartner_VuKhi][1],
		self.tbInfoPartnerEquip[1988].tbInfo[LvPartner_VuKhi][2]);		
	elseif (szWnd == self.IMG_Ao) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Ao] .." Chiến Y<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Ao] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Ao] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Ao.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1989].szDesc .."",
		self.tbInfoPartnerEquip[1989].tbInfo[LvPartner_Ao][1],
		self.tbInfoPartnerEquip[1989].tbInfo[LvPartner_Ao][2]);
	elseif (szWnd == self.IMG_NHAN) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Nhan] .." Giới Chỉ<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Nhan] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Nhan] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Nhan.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1990].szDesc .."",
		self.tbInfoPartnerEquip[1990].tbInfo[LvPartner_Nhan][1],
		self.tbInfoPartnerEquip[1990].tbInfo[LvPartner_Nhan][2],
		self.tbInfoPartnerEquip[1990].tbInfo[LvPartner_Nhan][3],
		self.tbInfoPartnerEquip[1990].tbInfo[LvPartner_Nhan][4]);		
	elseif (szWnd == self.IMG_TAY) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Tay] .." Hộ Uyển<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Tay] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Tay] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Tay.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1991].szDesc .."",
		self.tbInfoPartnerEquip[1991].tbInfo[LvPartner_Tay][1],
		self.tbInfoPartnerEquip[1991].tbInfo[LvPartner_Tay][2]);
	elseif (szWnd == self.IMG_PHU) then
		szTip = string.format("<color=yellow>".. self.tbInfoPartnerEquip_Define.szType[LvPartner_Phu] .." Hộ Thân Phù<color>\n"..
		"\n   ".. self.tbInfoPartnerEquip_Define.szStars[LvPartner_Phu] .."\n"..	
		"<color=cyan>Tài phú:<color> <color=green>".. self.tbInfoPartnerEquip_Define.nHonor[LvPartner_Phu] .."<color>\n\n"..	
		"Phù Đồng Hành     Đã khóa\n"..
		"Không đổi được Không tách được Không thể luyện hóa\n\n"..
		"Trang bị yêu cầu: 100\n"..
		"Cấp trang bị: "..LvPartner_Phu.." Ngũ hành: Vô\n\n"..			
		"".. self.tbInfoPartnerEquip[1992].szDesc .."",
		self.tbInfoPartnerEquip[1992].tbInfo[LvPartner_Phu][1],
		self.tbInfoPartnerEquip[1992].tbInfo[LvPartner_Phu][2],
		self.tbInfoPartnerEquip[1992].tbInfo[LvPartner_Phu][3],
		self.tbInfoPartnerEquip[1992].tbInfo[LvPartner_Phu][4]);
	end
	
	if (szTip ~= "") then
		Wnd_ShowMouseHoverInfo(self.UIGROUP, szWnd, "", szTip);
	end	
end
function uiPartner:RegisterEvent()
	local tbRegEvent = 
	{
		{ UiNotify.emCOREEVENT_SYNC_PARTNER,	self.Update },
		{ UiNotify.emCOREEVENT_SYNC_ITEM,		self.UpdatePartnerEquip },
	};
	tbRegEvent = Lib:MergeTable(tbRegEvent, self.tbObjSkillView:RegisterEvent());
	for _, tbCont in pairs(self.tbObjEquipView) do
		tbRegEvent = Lib:MergeTable(tbRegEvent, tbCont:RegisterEvent());
	end
	return tbRegEvent;
end

function uiPartner:RegisterMessage()
	local tbRegMsg = self.tbObjSkillView:RegisterMessage();
	for _, tbCont in pairs(self.tbObjEquipView) do
		tbRegMsg = Lib:MergeTable(tbRegMsg, tbCont:RegisterMessage());
	end
	return tbRegMsg;
end

function uiPartner:SetEquipPosHighLight(tbObj)
	local nRet = 1;
	if not tbObj or tbObj.nType ~= Ui.OBJ_OWNITEM then
		self:ReleaseEquipPosHighLight();
		return;
	end
	local pItem = me.GetItem(tbObj.nRoom, tbObj.nX, tbObj.nY);
	if (not pItem) or (not pItem.nEquipPos) or (pItem.nEquipPos < Item.EQUIPPOS_NUM)then
		self:ReleaseEquipPosHighLight();
		return;
	end
	-- me.Msg("tbObj.nRoom partner: " .. tostring(tbObj.nRoom));
	-- me.Msg("tbObj.nX partner: " .. tostring(tbObj.nX));
	-- me.Msg("tbObj.nY partner: " .. tostring(tbObj.nY));
	-- me.Msg("pItem.nEquipPos partner: " .. tostring(pItem.nEquipPos));
	local nPosition = pItem.nEquipPos - Item.EQUIPPOS_NUM;
	local tbEquipWnd = self:GetEquipWndTableItem(nPosition);
	if tbEquipWnd then
		self.m_szHighLightEquipPos = tbEquipWnd[3];
		Img_SetFrame(self.UIGROUP, self.m_szHighLightEquipPos, 0);
	end	
end

function uiPartner:ReleaseEquipPosHighLight()
	if self.m_szHighLightEquipPos == nil then
		return;
	end
	Img_SetFrame(self.UIGROUP, self.m_szHighLightEquipPos, 1);
	self.m_szHighLightEquipPos = nil;
end

function uiPartner:GetEquipWndTableItem(nPosition)
	for _, tbEquipItem in ipairs(PARTNER_EQUIP_OBJ_CONFIGER) do
		if tbEquipItem[1] == nPosition then
			return tbEquipItem;
		end
	end
end
